"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformSchema = void 0;
const components_object_js_1 = __importDefault(require("./components-object.js"));
const paths_object_js_1 = __importDefault(require("./paths-object.js"));
const schema_object_map_js_1 = __importDefault(require("./schema-object-map.js"));
const webhooks_object_js_1 = __importDefault(require("./webhooks-object.js"));
function transformSchema(schema, ctx) {
    if (!schema)
        return {};
    const output = {};
    if (schema.paths)
        output.paths = (0, paths_object_js_1.default)(schema.paths, ctx);
    else
        output.paths = "";
    if (schema.webhooks)
        output.webhooks = (0, webhooks_object_js_1.default)(schema.webhooks, ctx);
    else
        output.webhooks = "";
    if (schema.components)
        output.components = (0, components_object_js_1.default)(schema.components, ctx);
    else
        output.components = "";
    if (schema.$defs)
        output.$defs = (0, schema_object_map_js_1.default)(schema.$defs, { path: "$defs/", ctx });
    else
        output.$defs = "";
    return output;
}
exports.transformSchema = transformSchema;
//# sourceMappingURL=index.js.map