"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const utils_js_1 = require("../utils.js");
const path_item_object_js_1 = __importDefault(require("./path-item-object.js"));
function transformWebhooksObject(webhooksObject, ctx) {
    let { indentLv } = ctx;
    const output = ["{"];
    indentLv++;
    for (const [name, pathItemObject] of (0, utils_js_1.getEntries)(webhooksObject, ctx.alphabetize, ctx.excludeDeprecated)) {
        output.push((0, utils_js_1.indent)(`${(0, utils_js_1.escStr)(name)}: ${(0, path_item_object_js_1.default)(pathItemObject, {
            path: `#/webhooks/${name}`,
            ctx: { ...ctx, indentLv },
        })};`, indentLv));
    }
    indentLv--;
    output.push((0, utils_js_1.indent)("}", indentLv));
    return output.join("\n");
}
exports.default = transformWebhooksObject;
//# sourceMappingURL=webhooks-object.js.map